
{$APPTYPE GUI}{$MODE DELPHI}

program demo67;

uses
  SysUtils,windows,math,gl,glu,GraphOGL;

//const
 
//type
  
var 
  i:integer;
  MyVert:array[0..1]of TGLVertex3f;
  pos:TGLVector;
  
   
//{$R *.rc}
//{$R *.res}  
 

procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1,1, 0,1, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure Star;
begin
  Quad(-0.3,-0.3,0, 0.3,-0.3,0, -0.3,0.3,0, 0.3,0.3,0);
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('Floor05.bmp',0);
  TextureLoadTGAID('ParticleFire.tga',0);
  TextureLoadTGAID('jet.tga',1);
  
end;
begin 

  OpenGL_Texture();
  

  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-1,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(25,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1); 
  
  // terreno
  glSetMaxVertex3f(MyVert[1],4);
  glSetVertex3f(0,-3,0, 4);      
  TextureSelectID(0);
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
   
  TextureTGASelectID(0);
  for i:=1 to glGetMaxVertex3f-1 do
  begin
    pos:=glGetVertex3f(i);  
    glPushMatrix;
    glTranslatef(pos.x,pos.y,pos.z);    
    glRotatef(90,1,0,0); 
    FX_Beam(glvector(0,0,0),glvector(0,0,0),4,1,Star);  
    glPopMatrix;
  end;  

  // sfera 
  glSetMaxVertex3f(MyVert[0],796);   
  glPushMatrix;
  glTranslatef(0,6,0);    
  glRotatef(90,1,0,0); 
  VertexRemoveON; // attiva la cancellazione dei vertici e dei relativi poligoni  
  Sfera(0,0,0, 4,20,20, 1/3);
  VertexRemoveOFF; // dsattiva la cancellazione dei vertici e dei relativi poligoni
  
  TextureTGASelectID(0);  
  for i:=1 to(glGetMaxVertex3f div 2)+64 do
  begin
    pos:=glGetVertex3f(i);  
    glPushMatrix;
    glTranslatef(pos.x,pos.y,pos.z);    
    glRotatef(90,1,0,0); 
    FX_Beam(glvector(0,0,0),glvector(0,0,0),4,1,Star);
    glPopMatrix;
  end;   
  TextureTGASelectID(1);  
  for i:=(glGetMaxVertex3f div 2)+64 to glGetMaxVertex3f-1 do
  begin
    pos:=glGetVertex3f(i);  
    glPushMatrix;
    glTranslatef(pos.x,pos.y,pos.z);    
    glRotatef(90,1,0,0); 
    FX_Beam(glvector(0,0,0),glvector(0,0,0),4,1,Star);
    glPopMatrix;
  end;  
  glPopMatrix;  
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Interazioni con i vertici di modelli predefiniti', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
